"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Client = void 0;
const react_1 = __importStar(require("react"));
const json_server_orm_1 = require("json-server-orm");
const log_1 = require("./common/log");
const env_1 = require("./common/env");
const Table_1 = require("./Table");
const Object_1 = require("./Object");
require("./Client.scss");
function Client({ db, validation }) {
    if (!env_1.env.db)
        env_1.env.db = db;
    if (!env_1.env.validation)
        env_1.env.validation = validation;
    const names = react_1.useMemo(() => Object.keys(db), []);
    const rawname = react_1.useMemo(() => new URL(location.href).searchParams.get('table') ?? names[0], []);
    const [name, setName] = react_1.useState(rawname);
    const isTable = react_1.useMemo(() => db[name].isPlural, [name]);
    console.log('[client.Client]', isTable, json_server_orm_1.Table, db[name]);
    const [limit, setLimit] = react_1.useState(10);
    const [q, setQ] = react_1.useState('');
    log_1.log('[client.Client] begin', name, isTable ? 'table' : 'object');
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: 'panel' },
            react_1.default.createElement("select", { className: 'names', value: name, onChange: (ev) => setName(ev.target.value) }, names.map(o => react_1.default.createElement("option", { key: o, value: o }, o))),
            isTable && react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("select", { className: 'limit', value: limit, onChange: (ev) => (setLimit(parseInt(ev.target.value))) }, [1, 10, 50, 100, 0].map(o => react_1.default.createElement("option", { key: o, value: o }, o === 0 ? 'All' : (o + ' items')))),
                react_1.default.createElement("input", { className: 'q', type: 'text', placeholder: 'search', value: q, onChange: (ev) => setQ(ev.target.value) }))),
        isTable
            ? react_1.default.createElement(Table_1.TableUI, { db: db, name: name, limit: limit, q: q })
            : react_1.default.createElement(Object_1.ObjectUI, { db: db, name: name }));
}
exports.Client = Client;
